/*
 * ******************************************************************************************
 *
 * File		: apb_rtc_dev.c
 * Author	: GOWIN
 * Function	: Device definition of APB RTCx
 *
 * ******************************************************************************************
 */

// Includes ---------------------------------------------------------------------------------
#include "apb_rtc_dev.h"
#include "apb_rtc_driver.h"


// Definitions ------------------------------------------------------------------------------

// Initializes APB RTCx
int apb_rtcx_initialize(APB_RTC_SignalEvent_t cb_event)
{
	return apb_rtc_initialize(cb_event, &apb_rtcx_resources);
}

// Uninitialized
int apb_rtcx_uninitialize(void)
{
	return apb_rtc_uninitialize(&apb_rtcx_resources);
}

// Power control
int apb_rtcx_power_control(APB_RTC_POWER_STATE state)
{
	return apb_rtc_power_control(state, &apb_rtcx_resources);
}

// Set time
int apb_rtcx_set_time(APB_RTC_TIME* stime)
{
	return apb_rtc_set_time(stime, &apb_rtcx_resources);
}

// Get time
int apb_rtcx_get_time(APB_RTC_TIME* stime)
{
	return apb_rtc_get_time(stime, &apb_rtcx_resources);
}

// Set alarm
int apb_rtcx_set_alarm(APB_RTC_ALARM* salarm)
{
	return apb_rtc_set_alarm(salarm, &apb_rtcx_resources);
}

// Get alarm
int apb_rtcx_get_alarm(APB_RTC_ALARM* salarm)
{
	return apb_rtc_get_alarm(salarm, &apb_rtcx_resources);
}

// Control
int apb_rtcx_control(unsigned int control, unsigned int arg)
{
	return apb_rtc_control(control, arg, &apb_rtcx_resources);
}

// Get status
APB_RTC_STATUS apb_rtcx_get_status(void)
{
	return apb_rtc_get_status(&apb_rtcx_resources);
}

// APB RTCx period interrupt handler
void apb_rtcx_period_irq_handler(void)
{
	apb_rtc_period_irq_handler(&apb_rtcx_resources);
}

// APB RTCx alarm interrupt handler
void apb_rtcx_alarm_irq_handler(void)
{
	apb_rtc_alarm_irq_handler(&apb_rtcx_resources);
}
